Require Import ssreflect ssrbool ssrnat eqtype ssrfun seq.
Require Import pred prelude idynamic domain pcm unionmap heap coding feap.
Require Import state zigzag world atomic rely inject schedule refine hide.
Require Import footprint process always model privstate stsep autosplit.
Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Section ExtraLemmas.

Variable hp : nat.
Variable R : mod.
Notation P := (Priv hp).
Notation W := (entangle (Priv hp) R).
Notation cohP := (Mod.coh P).
Notation cohR := (Mod.coh R). 
Notation coh := (Mod.coh W). 

Lemma split_cohP st (hS hO : heap):
   hp ->> [hS, tt, hO] \+ st \In coh -> hp ->> [hS, tt, hO] \In Mod.coh (Priv hp).
Proof.
move=>C; apply/(star_coh_prec C); case: (C)=>Vh [s1][s2][E] C1 C2. 
case: (C1)=> V1[hL][hE]E'; subst s1.
by move/(scancel (validHV Vh)): E; case; case; move=>?? _->; subst hL hE.
Qed.

Lemma split_PE s: s \In coh ->
  exists (hS hO: heap) st, 
    s = hp ->> [hS, tt, hO] \+ st.
Proof.
move=>[Vh][s1 [s2]][Z]; subst s. 
case=>Vh1[hL][hE]Z C2; subst s1.
by eexists _, _ ,_.
Qed.

Definition menv_stable V (P: state -> Prop) : Prop :=
  forall (s1 s2: state), P s1 -> menv_steps V s1 s2 -> P s2.

Lemma menvs_stable (hS hO: heap) P st i: 
  menv_stable R P -> 
  menv_steps W (hp ->> [hS, tt, hO] \+ st) i -> P st ->
  exists hO' st', i = hp ->> [hS, tt, hO'] \+ st' /\ P st'.
Proof.
move=>S M A; case/menvs_coh: (M)=>C1 C2.
move/(split_PE): (C2)=>[hS'][hO'][j']Z; subst i.
move:(menvs_split (entangle_extL _ _) (split_cohP C1) (split_cohP C2) M)=>[Mp]Mt.
have X1: hS = hS'. 
  case/mtx_priv: Mp=>hO2; rewrite stE !fsE /=; case.
  by move/(fcancelPt (C:=pcmCode))=>Z1 _ /(fcancelPt (C:=pcmCode)) Z2. subst hS'.
exists hO', j'; split=>//. 
by move:(S st j' A Mt).
Qed.

End ExtraLemmas.